MODULE  FillHermitian
  !
  !  Routine to generate a random Hermitian matrix.
  !
  !  The code was created for hands-on based 
  !  training @ the ICTP for SMR2706 
  !
  !  Developed by: I. Girotto ( igirotto@ictp.it )
  !
  ! 
  !
  IMPLICIT NONE
  
  PUBLIC ::  FillMatrix

contains

  SUBROUTINE fillMatrix( A, rows, cols )

    IMPLICIT NONE

    REAL*8 :: temp 
    INTEGER, INTENT( IN ) ::  rows, cols
    INTEGER :: i , j
    REAL * 8, DIMENSION( :, : ), INTENT( OUT ) ::  A

    temp = 0.D0 

    CALL RANDOM_SEED()

    Do j = 1, cols
       DO i = 1, rows
          CALL RANDOM_NUMBER( temp )
          A( i, j ) =  temp 

       END DO
    END DO

  END SUBROUTINE fillMatrix

END MODULE FillHermitian
