/* 
 * Routine to generate a random Hermitian matrix for using LAPACKE (C interface)
 *
 * Code created for hands-on based evaluation for the course
 * "P1.2 Introduction to Computer Architecture for HPC"
 * for the Master in High Performance Computing @SISSA/ICTP
 *
 * Developed by: G.P. Brandino (brandino@sissa.it) and M. Atambo (matambo@ictp.it) 
 * Reviewd by: I. Girotto ( igirotto@ictp.it )
 *
 */

#include <stdlib.h>
#include <math.h>
#include "utils_lapacke.h"

void FillMatrix_lapacke( MKL_Complex16 *A, int n ){

  double temp, temp1;
  int i,j ;

  srand( time(NULL) );

  for ( i = 0; i < n; i++ ){
    for ( j = 0; j < i; j++ ){
      
      if( i == j ){
             
	temp = rand() / ( (double) RAND_MAX );
	A[ i * n + j ].real = temp;
	A[ i * n + j ].imag = 0.0;
      }
      else{
	
	temp = rand() / ( (double) RAND_MAX );
	temp1 = rand() / ( (double) RAND_MAX );
	A[ i * n + j ].real = temp;
	A[ i * n + j ].imag = temp1;
	A[ j * n + i ].real = temp;
	A[ j * n + i ].imag = -temp1;
      }
    }
  }
}
