MODULE  FillHermitian
!
! Routine to generate a random Hermitian matrix.
! 
! Code created for hands-on based evaluation for the course
! "P1.2 Introduction to Computer Architecture for HPC"
! for the Master in High Performance Computing @SISSA/ICTP
!
! Developed by: G.P. Brandino (brandino@sissa.it) and M. Atambo (matambo@ictp.it) 
! Reviewd by: I. Girotto ( igirotto@ictp.it )
!

  IMPLICIT NONE
  
  PUBLIC ::  FillMatrix

contains

  SUBROUTINE fillMatrix( A, n )

    IMPLICIT NONE

    REAL*8 :: temp, temp1
    INTEGER, INTENT( IN ) ::  n
    INTEGER :: i , j
    COMPLEX*16, DIMENSION( :, : ), INTENT( OUT ) ::  A

    temp = 0.D0 

    CALL RANDOM_SEED()

    Do j = 1, n
       DO i = j, n

          IF ( i .EQ. j ) THEN

             CALL RANDOM_NUMBER( temp )
             A( i, j ) = cmplx( temp, 0.D0 ) 

          ELSE 
             
             CALL RANDOM_NUMBER( temp )
             CALL RANDOM_NUMBER( temp1 )
             A( i, j ) = cmplx( temp, temp1 ) 
             A( j, i ) = CONJG( A( i, j ) )

          END IF

       END DO
    END DO

  END SUBROUTINE fillMatrix

END MODULE FillHermitian
